function [yf, ydotf, yddotf, start] = fir_filter(y, ydot, yddot, h, order, start0, stop0)

start = start0+(order/2);
stop = stop0-(order/2)-2;

% Filters the derivative data
for k = start:stop
    yfd = 0;
    ydotfd = 0;
    yddotfd = 0;
    for i = 1:order+1
        yfd = yfd + h(i) * y(k - (order/2) + i);
        ydotfd = ydotfd + h(i) * ydot(k - (order/2) + i);
        yddotfd = yddotfd + h(i) * yddot(k - (order/2) + i);
    end
    yf(k,1) = yfd;
    ydotf(k,1) = ydotfd;
    yddotf(k,1) = yddotfd;
end
