clear 
load data03.mat
close all
predictionPeriod = 1


y = pm*pi/180;
T = 0.02;
start = 2;
stop = length(t);

[ydot, yddot] = num_derivatives_from_location_data(y,T,start,stop);

L = length(y);
NFFT = 2^nextpow2(L);

f_res = 1/T/length(y);
f = (0:length(y)-1)*f_res;

f = 1/T/2*linspace(0,1,NFFT/2+1);
Y = fft(y,NFFT)/L;
Ymag = abs(Y);
figure
plot(f,Ymag(1:NFFT/2+1))
title('Single-Sided Amplitude Spectrum of y(t)','Interpreter','Latex')
xlabel('frequency f [Hz]','Interpreter','Latex')
ylabel('Signal amplitude Y(f)','Interpreter','Latex')
% xlim([0 2])
% ylim([0 0.1])
grid on
%%
order_fir = 100;       % FIR filter order
Fp  = 1; % Cutoff frequency (Hz)
Fs  = 1/T;       
h = fir1(order_fir,Fp*2*T);  % Calculated FIR filter

[yf, ydotf, yddotf, start_after_filt] = fir_filter(y, ydot, yddot, h, order_fir, start, stop);

 L = length(yf);
NFFT = 2^nextpow2(L);

f_res = 1/T/length(yf);
f = (0:length(yf)-1)*f_res;

f = 1/T/2*linspace(0,1,NFFT/2+1);
Yf = fft(yf,NFFT)/L;
Ymag = abs(Yf);

plot(f,Ymag(1:NFFT/2+1))
figure 
plot(f,(abs(Y(1:NFFT/2+1)- Yf(1:NFFT/2+1))))
title('Difference between amplitude Spectra of y(t) and filtered y(t)','Interpreter','Latex')
xlabel('Frequency f [Hz]','Interpreter','Latex')
ylabel('Difference between spectra Y(f) - Yf(f)','Interpreter','Latex')
xlim([0 5])
grid on


