%clear 
load data03.mat
figure
subplot(2,1,1)
plot(t,u)
subplot(2,1,2)
plot(t,pm)

y = pm*pi/180

T = 0.02
start = 2
N = length(t)

for k = start:N-1
   ydot(k) = (y(k+1)-y(k-1))/(2*T); 
   yddot(k) = (y(k+1)-2*y(k)+y(k-1))/(T^2);
end

figure
subplot(3,1,1)
plot(y*180/pi)
title('y')
subplot(3,1,2)
plot(ydot*180/pi)
title('ydot')
subplot(3,1,3)
plot(yddot*180/pi)
title('yddot')
%%
L = length(y);
NFFT = 2^nextpow2(L);

f_res = 1/T/length(y);
f = (0:length(y)-1)*f_res;

f = 1/T/2*linspace(0,1,NFFT/2+1);
Y = fft(y,NFFT)/L;
Ymag = abs(Y);
figure
plot(f,Ymag(1:NFFT/2+1))
title('Single-Sided Amplitude Spectrum of y(t)')
xlabel('f (Hz)')
ylabel('|P1(f)|')
grid on



%% FIR filter
order_fir = 100       % FIR filter order
Wn_fir = 1*2*pi % Cutoff frequency (rad/s)

Fp  = Wn_fir/(2*pi)
%Fp = 1
Fs  = 1/T;       
h = fir1(order_fir,Fp/(Fs/2))  % Calculated FIR filter

% Filters the derivative data
k0 = start+(order_fir/2)
kend = N-(order_fir/2)-2
for k = start+(order_fir/2):N-(order_fir/2)-2
    yfd = 0;
    ydotfd = 0;
    yddotfd = 0;
    for i = 1:order_fir+1
        yfd = yfd + h(i) * y(k - (order_fir/2) + i);
        ydotfd = ydotfd + h(i) * ydot(k - (order_fir/2) + i);
        yddotfd = yddotfd + h(i) * yddot(k - (order_fir/2) + i);
    end
    yf_fir(k) = yfd;
    ydotf_fir(k) = ydotfd;
    yddotf_fir(k) = yddotfd;
end

figure
subplot(3,1,1)
plot(yf_fir(k0:kend)*180/pi)
title('y filtered')
subplot(3,1,2)
plot(ydotf_fir(k0:kend)*180/pi)
title('ydot filtered')
subplot(3,1,3)
plot(yddotf_fir(k0:kend)*180/pi)
title('yddot filtered')
%% FIR Identification
y_offset = 0*pi/180
Nmax = min([length(ydotf_fir) length(yf_fir) length(u)]);
start = max(15,k0);
for n = start:Nmax
    Phi_fir(n-start+1, :) = [ -ydotf_fir(n)  -sin(yf_fir(n) + y_offset)  u(n) 1];
end

Theta_fir = pinv(Phi_fir)*yddotf_fir(start:Nmax)'

H = Phi_fir*inv(Phi_fir'*Phi_fir)*Phi_fir';

epsilon_fir = (eye(length(H))-H)*yddotf_fir(start:Nmax)';

%MG kontrola rezidua
yhat_fir=Phi_fir*Theta_fir;
e = yddotf_fir(start:Nmax)'-yhat_fir; %kontrola rezidua, jednodussi vypocet nez opet pres inverzi vyse

%MG pozor na pocatecni velkou odchylku v epsilon - ze zaznamu se musi
%vyriznout pocatecni cast, kde filtry pro derivace nejsou jeste
%vysledovane, tady cca od 13 vzorku dal

mean_fir = mean(epsilon_fir) 


s2_fir = ((epsilon_fir-mean_fir)'*(epsilon_fir-mean_fir))/(Nmax-length(Theta_fir))

cove_fir = s2_fir*(eye(length(H))-H);

cov_theta_fir = s2_fir * inv(Phi_fir'*Phi_fir)

max(abs(e))

figure
subplot(2,1,1)
hold on
title('Shoda yhat a filtrované druhé derivace')
plot(yddotf_fir(start:Nmax)*180/pi)
plot(yhat_fir*180/pi)
xlabel('time-step k')
ylabel('y" [°.s^-2]')
legend('yddotf_fir', 'yhat_fir')

subplot(2,1,2)
plot(e*180/pi)
title('e')
xlabel('time-step k')
ylabel('e [°.s^-2]')
%%
clear Phi_fir
k = 1
for y_offset = 0:2:2
    
    y_offset = y_offset*pi/180
    
    Nmax = min([length(ydotf_fir) length(yf_fir) length(u)]);
    start = max(15,k0);
    for n = start:Nmax
        Phi_fir(n-start+1, :) = [ -ydotf_fir(n)  -sin(yf_fir(n) + y_offset)  u(n) 1];
    end

    Theta_fir = pinv(Phi_fir)*yddotf_fir(start:Nmax)'

    H = Phi_fir*inv(Phi_fir'*Phi_fir)*Phi_fir';

    epsilon_fir = (eye(length(H))-H)*yddotf_fir(start:Nmax)';

    %MG kontrola rezidua
    yhat_fir=Phi_fir*Theta_fir;
    e = yddotf_fir(start:Nmax)'-yhat_fir; %kontrola rezidua, jednodussi vypocet nez opet pres inverzi vyse

    %MG pozor na pocatecni velkou odchylku v epsilon - ze zaznamu se musi
    %vyriznout pocatecni cast, kde filtry pro derivace nejsou jeste
    %vysledovane, tady cca od 13 vzorku dal

    mean_fir = mean(epsilon_fir) 


    s2_fir = ((epsilon_fir-mean_fir)'*(epsilon_fir-mean_fir))/(Nmax-length(Theta_fir))

    cove_fir = s2_fir*(eye(length(H))-H);

    cov_theta_fir = s2_fir * inv(Phi_fir'*Phi_fir)
    
    s(k) = s2_fir
    emax(k) = max(abs(e))
    k = k+1
    
    figure('Name',sprintf('%.0f',(y_offset*180/pi)))
    subplot(2,1,1)
    hold on
    title('yhat')
    plot(yddotf_fir(start:Nmax))
    plot(yhat_fir)
    legend('yddotf_fir', 'yhat_fir')
    subplot(2,1,2)
    plot(e)
end
%%

figure
title('max(abs(e))')
plot(0:2:360, emax*180/pi)
xlabel('y offset [°]')
ylabel('e max [°.s^-2]')
