% správnost offsetu vyhodnotit podle schopnosti predikce dynamiky
% pro offset identifikovat parametry => nacpat do nelin dyn modelu ->
% prubezne (kazdych 10 kroku) nastavit polohu simulace na namerena data
% (vypoctene derivace)
% z odchylky pocitat MSE, RMS, pk-pk
% spravny offset =~ 40

%yddot + ydot + sin(y + offset) = u



clear 
load data03.mat
predictionPeriod = 1

for k = 1:20
    offsetstep = 5; % in degrees
    y_offset = ((k-1)*offsetstep)*pi/180; % Po peti stupnich


    y = pm*pi/180 + y_offset;
    T = 0.02;
    start = 2;
    stop = length(t);

    [ydot, yddot] = num_derivatives_from_location_data(y,T,start,stop);

    fft_viz(y,T)

    order_fir = 100;       % FIR filter order
    Fp  = 1; % Cutoff frequency (Hz)
    Fs  = 1/T;       
    h = fir1(order_fir,Fp*2*T);  % Calculated FIR filter

    [yf, ydotf, yddotf, start_after_filt] = fir_filter(y, ydot, yddot, h, order_fir, start, stop);

    % y_offset = 40;
    % Theta = identify(yf,ydotf,yddotf, u, y_offset, start_after_filt)

    %%
    %time series for simulink 
    y_ts = [(start_after_filt:length(yf))'*T yf(start_after_filt:end)];
    ydot_ts = [(start_after_filt:length(yf))'*T ydotf(start_after_filt:end)];
    yddot_ts = [(start_after_filt:length(yf))'*T yddotf(start_after_filt:end)];
    u_ts = [(start_after_filt:length(yf))'*T u(start_after_filt:length(yf))];


    Theta(:,k) = identify(yf,ydotf,yddotf, u, y_offset, start_after_filt)

    sim('predictionHorizon')

    len = min(length(y_pred),length(yf));


    NormVec(k) = norm(e_pred)

%     e =( y_pred(start_after_filt:len) - yf(start_after_filt:len));
%     edot = (ydot_pred(1:len) - ydotf(1:len));
%     eddot = (yddot_pred(1:len) - yddotf(1:len));

%     MSE(k) = mean(e.^2);
%     MSEdot(k) = mean(edot.^2);
%     MSEddot(k) = mean(eddot.^2);
% 
%     RMS(k) = sqrt(MSE(k));
%     RMSdot(k) = sqrt(MSEdot(k));
%     RMSddot(k) = sqrt(MSEddot(k));
% 
%     pkpky(k) = max(e)-min(e);
%     pkpkydot(k) = max(edot)-min(edot);
%     pkpkyddot(k) = max(eddot)-min(eddot);
end

%%
% figure
% hold on
% plot((0:length(MSE)-1)*offsetstep,MSE)
% plot((0:length(MSE)-1)*offsetstep,MSEdot)
% plot((0:length(MSE)-1)*offsetstep,MSEddot)
% legend('MSE','MSEdot', 'MSEddot')
% xlabel('offset [stupne]')
% figure
% hold on
% plot((0:length(MSE)-1)*offsetstep,pkpky)
% plot((0:length(MSE)-1)*offsetstep,pkpkydot)
% plot((0:length(MSE)-1)*offsetstep,pkpkyddot)
% legend('pkpky','pkpkydot', 'pkpkyddot')
% xlabel('offset [stupne]')



figure
hold on
plot((0:length(NormVec(1,:))-1)*offsetstep,NormVec(1,:))
%plot((0:length(NV(3,:))-1)*offsetstep,NV(3,:))
title('Error vector norm $\vert e \vert (\varphi_{offset})$','fontsize',14,'interpreter','latex')
xlabel('$\varphi_{offset} [^{\circ}]$','fontsize',14,'interpreter','latex')
ylabel('$\vert e \vert$','fontsize',14,'interpreter','latex')
legend('1s prediction horizon')

%% Vyhodnoceni pro jeden konkretni offset

y_offset = 40*pi/180; % Po peti stupnich
predictionPeriod = 1

y = pm*pi/180 + y_offset;
T = 0.02;
start = 2;
stop = length(t);

[ydot, yddot] = num_derivatives_from_location_data(y,T,start,stop);

%fft_viz(y,T)

order_fir = 100;       % FIR filter order
Fp  = 1; % Cutoff frequency (Hz)
Fs  = 1/T;       
h = fir1(order_fir,Fp*2*T);  % Calculated FIR filter

[yf, ydotf, yddotf, start_after_filt] = fir_filter(y, ydot, yddot, h, order_fir, start, stop);

%time series for simulink 
y_ts = [(start_after_filt:length(yf))'*T yf(start_after_filt:end)];
ydot_ts = [(start_after_filt:length(yf))'*T ydotf(start_after_filt:end)];
yddot_ts = [(start_after_filt:length(yf))'*T yddotf(start_after_filt:end)];
u_ts = [(start_after_filt:length(yf))'*T u(start_after_filt:length(yf))];

Theta(:,k) = identify(yf,ydotf,yddotf, u, y_offset, start_after_filt)

sim('predictionHorizon')
% 
% figure
% hold on
% plotlen = min(length(y_ts(:,1)), length(y_pred))
% plot(y(1:end,1),y_ts(1:end,2))
% plot(y_ts(1:plotlen,1),y_pred(1:plotlen,1))
figure
hold on
plot(y_real_ts)
plot(y_pred_ts)
title('$\varphi (t)$ for $\varphi_{offset} = 40^{\circ}$','fontsize',14,'interpreter','latex')
xlabel('Time [s]','fontsize',14,'interpreter','latex')
ylabel('$\varphi [rad]$','fontsize',14,'interpreter','latex')
legend('Real world experiment data', '1s prediction horizon')