% správnost offsetu vyhodnotit podle schopnosti predikce dynamiky
% pro offset identifikovat parametry => nacpat do nelin dyn modelu ->
% prubezne (kazdych 10 kroku) nastavit polohu simulace na namerena data
% (vypoctene derivace)
% z odchylky pocitat MSE, RMS, pk-pk
% spravny offset =~ 40

%yddot + ydot + sin(y + offset) = u



clear 
close all
load data03.mat
predictionPeriod = 1

y_offset = 40*pi/180

y = pm*pi/180 + y_offset;
T = 0.02;
start = 2;
stop = length(t);

[ydot, yddot] = num_derivatives_from_location_data(y,T,start,stop);

fft_viz(y,T)

order_fir = 100;       % FIR filter order
Fp  = 0.5; % Cutoff frequency (Hz)
Fs  = 1/T;       
h = fir1(order_fir,Fp*2*T);  % Calculated FIR filter

[yf, ydotf, yddotf, start_after_filt] = fir_filter(y, ydot, yddot, h, order_fir, start, stop);

% y_offset = 40;
% Theta = identify(yf,ydotf,yddotf, u, y_offset, start_after_filt)

%%
%time series for simulink 
y_ts = [(start_after_filt:length(yf))'*T yf(start_after_filt:end)];
ydot_ts = [(start_after_filt:length(yf))'*T ydotf(start_after_filt:end)];
yddot_ts = [(start_after_filt:length(yf))'*T yddotf(start_after_filt:end)];
u_ts = [(start_after_filt:length(yf))'*T u(start_after_filt:length(yf))];


[Theta(:), a, Phi] = identify(yf,ydotf,yddotf, u, y_offset, start_after_filt)

% H = Phi*inv(Phi'*Phi)*Phi';
% epsilon = (eye(length(H))-H)*yddotf(1:length(H))
% yhat=Phi*Theta';
% e = yddotf(start:length(H))'-yhat; %kontrola rezidua, jednodussi vypocet nez opet pres inverzi vyse
 sim('predictionHorizon1')
epsilon = e_pred

mean_eps = mean(epsilon) 
% mean_eps = 0
s2 = ((epsilon-mean_eps)'*(epsilon-mean_eps))/(length(H)-length(Theta))
cove = s2*(eye(length(H))-H);
cov_theta = s2 * inv(Phi'*Phi)

%

% len = min(length(y_pred),length(yf));


% norm(e_pred)



