clear all
close all
y_lin = 90
Theta = [0.4554  %Identifikovane parametry
        3.2503
        13.3097]
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F,Ts,'zoh')
plant_ss = ss(Fd)

%y_offset = 40

u0 = Theta(2)*sin((y_lin)*pi/180)/Theta(3) % ustaleny vstup pro y_lin

t = 0:Ts:100
%%

A = [[plant_ss.A [0;0] [0;0] [0;0]]; [0 0 1 0 0];[0 0 0 1 0]; [0 0 0 0 1]] 
B = [plant_ss.B; 0; 0; 0]
C = [plant_ss.C 0 0 0]
Ce = [plant_ss.C -1 0 1]
D = plant_ss.D
%Rozsirene stavove matice pro MPC

% Ar = [[plant_ss.A [0;0]];[0 0 1]] 
% Br = [plant_ss.B; 0]
% Cr = [plant_ss.C 1]
% 
% rank(obsv(plant_ss.A,plant_ss.C))
% rank(obsv(Ar,Cr))
% 
% Krek = place(Ar,Cr', [-0.5 0.5 0.1])
% eig(Ar-Cr * Krek')
% syms k1 k2 k3
% Arek = Ar-[k1 k2 k3]*Cr'
% Arek = vpa(Arek,3)
% ddd = vpa(det(Arek),3)
% % [ 1.99 - 0.0423*k2 - 1.0*k3 - 0.0425*k1, - 0.0425*k1 - 0.0423*k2 - 1.0*k3 - 0.991,     - 0.0425*k1 - 0.0423*k2 - 1.0*k3]
% % [  1.0 - 0.0423*k2 - 1.0*k3 - 0.0425*k1,         - 0.0425*k1 - 0.0423*k2 - 1.0*k3,     - 0.0425*k1 - 0.0423*k2 - 1.0*k3]
% % [      - 0.0425*k1 - 0.0423*k2 - 1.0*k3,         - 0.0425*k1 - 0.0423*k2 - 1.0*k3, 1.0 - 0.0423*k2 - 1.0*k3 - 0.0425*k1]
% subs(ddd, [k1,k2,k3],[1000, 10, -11])

% parameters
np = 50
nc = 10
% constraints
ub = (1-u0)*ones(nc,1)
lb = (0-u0)*ones(nc,1)
% weights
eW = 1 %output weight
duW = 1 %input weight

Q = eW*eye(size(C,1))
R = duW*eye(size(B,2))
cQ = cell(1,np)
cR = cell(1,nc)
cQ(:) = {Q}
cR(:) = {R}
Q = blkdiag(cQ{:}) % np*np
R = blkdiag(cR{:}) % nc*nc

%delta u matrices
K = eye(nc)-triu(ones(nc),-1)+triu(ones(nc),0)
M = zeros(nc,1)
M(1) = -1
L = [0 0 0 1 0]


% prediction matrices
Px = []
Hx = []
P = []
H = []
for r = 1:np
    Hx_row = []
    H_row = []
    for c = 1:np
        Hx_row = [Hx_row mat_pow(A, r-c)*B]
        H_row = [H_row Ce*mat_pow(A,r-c-1)*B]
    end
    Hx = [Hx ; Hx_row]
    H = [H ; H_row]
    Px = [Px ; A^r]   
    P = [P ; Ce*mat_pow(A,r-1)]
end
H = H - diag(diag(H))+eye(length(H))*D %uprava prvku na diagonale


% Move blocking
% Mb lze aplikovat na uk nebo na Hx a H (v nasem pripade se aplikuje na Hx a H)
Mb = [eye(nc);[zeros(np-nc,nc-1) ones(np-nc,1)]]
Hbx = Hx*Mb
Hb = H*Mb

% Inicializace zaznamovych vektoru
w0 = -0.5 % REFERENCNI SIGNAL
x(:,1) = [0;0;w0;0;1] % stavovy vektor rozsireny o referencni hodnotu a posledni u
v(1) = 0
y(1) = C*x(:,1)
e(1) = Ce*x(:,1)
du(:,1) = K*zeros(nc,1)+M*L*x(:,1)

% Pocatecni stav pro nelinearni model
yode = [(y_lin)*pi/180  0]
yfull = [0 0];
tfull = 0;

for k = 1:500
    % Optimalizace
    G = (Hb'*Q*Hb + K'*R*K);
    f = (x(:,k)'*(P'*Q*Hb + L'*M'*R*K))';
    %c(k) = 1/2*x(:,k)'*(P'*Q'*P + L'*M'*R*M*L)*x(:,k)
    uk = quadprog(G,f,[],[],[],[],lb,ub);
    
    J(k) = 1/2*(uk'*G*uk + f'*uk);
    
    u(k) = uk(1);
    
    
    tspan = [(k-1)*Ts k*Ts];
    [tode,yode] = ode45(@(tode,yode) pendulumEq(tode, yode , u(k) + u0, Theta, 0*pi/180), tspan, yode(end,:));
    yfull = [yfull; yode];
    tfull = [tfull; tode];
    
    %v(k+1) = y(k)+y_lin*pi/180 - yode(1,1); % Porucha
    % Zaznam vystupu
    x(:,k+1) = A*x(:,k)+B*u(k);% + [0;0;0;0;1]*v(k+1);

    
    % Nonlinearized model
    
    
    
    y(k+1) = C*x(:,k+1);
    e(k+1) = Ce*x(:,k+1);
    ek(:,k+1) = P*x(:,k)+Hb*uk;
    du(:,k+1) = K*uk+M*L*x(:,k);
    
    
    % Pravidelne sjednocovani stavu linearniho systemu s realnym
    % nelinearnim modelem
%     if mod(k,1) == 0
%         x(1:2,k+1) =  (yfull(end,1)-y_lin*pi/180)*pinv(C(1:2))
%     end
end

%% TODO
% Periodicky sjednocovat linearni predikci s merenim z nelinearniho systemu
% Overit spravnost na +- 40 stupnu okolo pracovniho bodu
% Slozitejsi w



time_v = (0:length(y)-1)*Ts;
figure
subplot(2,2,1)
hold on
stairs(time_v,y)
plot(time_v,ones(1,length(time_v))*w0,'r')
hold off
title('regulovana velicina y')
xlabel('t[s]')
subplot(2,2,2)
stairs(time_v,e)
title('regulacni odchylka e')
xlabel('t[s]')
subplot(2,2,3)
stairs(time_v(1:length(u)),u)
title('akcni zasah u')
xlabel('t[s]')
subplot(2,2,4)
stairs((1:length(du))*Ts,du(1,:))
title('zmena akcniho zasahu du')
xlabel('t[s]')

% 
% figure
% plot(tfull,yfull())

figure
hold on
plot(tfull, yfull(:,1))
plot(time_v, y+y_lin*pi/180)
plot([0, time_v(end)], ones(1,2)*(y_lin*pi/180+w0))
legend('Nonlinear system', 'Linear system', 'Setpoint')
title('MPC control output','fontsize',14,'interpreter','latex')
ylabel('$\varphi [rad]$','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

figure
hold on
plot(tfull, (yfull(:,1) - (y_lin*pi/180 + w0)))
plot(time_v, y-w0)
plot([0, time_v(end)], ones(1,2)*(0))
xlim([Ts time_v(end)])
legend('Nonlinear system', 'Linear system', 'Setpoint')
title('Output error','fontsize',14,'interpreter','latex')
ylabel('$\varphi [rad]$','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

figure
hold on
subplot(2,1,1)
plot(time_v, v)
title('Porucha','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')
subplot(2,1,2)
plot(time_v, x(5,:))
title('\Sum porucha','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

% 
% [X,Y] = meshgrid(-5000:500:5000);
% xJ = X(:);
% y = Y(:);
% sx = size(X);
% %G = [1 -0.5;-0.5 2]
% a=0.5*diag([xJ y]*G*[xJ';y'])+(f'*[xJ';y'])';
% %a=0.5*diag([xJ y]*G*[xJ';y'])';
% Z = reshape(a,sx);
% 
% figure
% surf(X,Y,Z)
% xlabel('u(1)')
% ylabel('u(2)')
% zlabel('J')
% title('Funkcional J(u) pro np = 5 a nc = 2')