clear all
close all
y_lin = 90
Theta = [0.4554  %Identifikovane parametry
        3.2503
        13.3097]
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F,Ts,'zoh')
plant_ss = ss(Fd)

%y_offset = 40

u0 = Theta(2)*sin((y_lin)*pi/180)/Theta(3) % ustaleny vstup pro y_lin

t = 0:Ts:100
%%

A = [[plant_ss.A [0;0] [0;0] [0;0]]; [0 0 1 0 0];[0 0 0 1 0]; [0 0 0 0 1]] 
B = [plant_ss.B; 0; 0; 0]
C = [plant_ss.C 0 0 0]
Ce = [plant_ss.C -1 0 0]
D = plant_ss.D


Ard = [plant_ss.A,plant_ss.B;[0 0 1]]
Brd = [plant_ss.B; 0]
Crd = [plant_ss.C 0]

Ld = acker(Ard',Crd', 1*[0 0 0] )'

Frekd = Ard-Ld*Crd
eig(Frekd)

% parameters
np = 1600
nc = 320
% constraints
ub = (1-u0)*ones(nc,1)
lb = (0-u0)*ones(nc,1)
% weights
eW = 1 %output weight
duW = 0.1 %input weight

Q = eW*eye(size(C,1))
R = duW*eye(size(B,2))
cQ = cell(1,np)
cR = cell(1,nc)
cQ(:) = {Q}
cR(:) = {R}
Q = blkdiag(cQ{:}) % np*np
R = blkdiag(cR{:}) % nc*nc

%delta u matrices
K = eye(nc)-triu(ones(nc),-1)+triu(ones(nc),0)
M = zeros(nc,1)
M(1) = -1
L = [0 0 0 1 0]


% prediction matrices
Px = []
Hx = []
P = []
H = []
for r = 1:np
    Hx_row = [];
    H_row = [];
    for c = 1:np
        Hx_row = [Hx_row mat_pow(A, r-c)*B];
        H_row = [H_row Ce*mat_pow(A,r-c-1)*B];
    end
    Hx = [Hx ; Hx_row];
    H = [H ; H_row];
    Px = [Px ; A^r];
    P = [P ; Ce*mat_pow(A,r-1)];
end
H = H - diag(diag(H))+eye(length(H))*D; %uprava prvku na diagonale


% Move blocking
% Mb lze aplikovat na uk nebo na Hx a H (v nasem pripade se aplikuje na Hx a H)
Mb = [eye(nc);[zeros(np-nc,nc-1) ones(np-nc,1)]];
Hbx = Hx*Mb;
Hb = H*Mb;

% Inicializace zaznamovych vektoru
w0 = -0.3 % REFERENCNI SIGNAL
z0 = -0.5

p = (P'*Q*Hb + L'*M'*R*K);
G = (Hb'*Q*Hb + K'*R*K);
%%
for k = 1:10
%     quadprog_sim = sim('quadprog_sim')
    OASESqp_sim = sim('OASESqp_sim')
    OASESqp_hs_sim = sim('OASESqp_hs_sim')

%     qp_total.y(:,k) = quadprog_sim.quadprog_sim.signals.values(:,1)
%     qp_total.u(:,k) = quadprog_sim.quadprog_sim.signals.values(:,2)
%     qp_total.t(:,k) = quadprog_sim.quadprog_sim.signals.values(:,3)
    OASESqp_total.y(:,k) = OASESqp_sim.OASESqp_sim.signals.values(:,1)
    OASESqp_total.u(:,k) = OASESqp_sim.OASESqp_sim.signals.values(:,2)
    OASESqp_total.t(:,k) = OASESqp_sim.OASESqp_sim.signals.values(:,3)
    OASESqp_hs_total.y(:,k) = OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,1)
    OASESqp_hs_total.u(:,k) = OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,2)
    OASESqp_hs_total.t(:,k) = OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,3)
end

% qp_avg.y = mean(qp_total.y,2)
% qp_avg.u = mean(qp_total.u,2)
% qp_avg.t = mean(qp_total.t,2)
OASESqp_avg.y = mean(OASESqp_total.y,2)
OASESqp_avg.u = mean(OASESqp_total.u,2)
OASESqp_avg.t = mean(OASESqp_total.t,2)
OASESqp_hs_avg.y = mean(OASESqp_hs_total.y,2)
OASESqp_hs_avg.u = mean(OASESqp_hs_total.u,2)
OASESqp_hs_avg.t = mean(OASESqp_hs_total.t,2)

%%

figure
subplot(2,1,1)
hold on
% plot(quadprog_sim.quadprog_sim.time,qp_avg.y)
plot(OASESqp_sim.OASESqp_sim.time, OASESqp_avg.y)
plot(OASESqp_hs_sim.OASESqp_hs_sim.time, OASESqp_hs_avg.y)
legend({'QP','OASESqp','OASESqphs'},'Interpreter','Latex')
legend({'OASESqp','OASESqphs'},'Interpreter','Latex')
subplot(2,1,2)
hold on
% plot(quadprog_sim.quadprog_sim.time,qp_avg.y)
plot(OASESqp_sim.OASESqp_sim.time, OASESqp_avg.y)
plot(OASESqp_hs_sim.OASESqp_hs_sim.time, OASESqp_hs_avg.y)
legend({'QP','OASESqp','OASESqphs'},'Interpreter','Latex')
legend({'OASESqp','OASESqphs'},'Interpreter','Latex')
xlabel('Time [s]')
ylabel('u')

figure
hold on
% plot(quadprog_sim.quadprog_sim.time, qp_avg.t)
plot(OASESqp_sim.OASESqp_sim.time, OASESqp_avg.t)
plot(OASESqp_hs_sim.OASESqp_hs_sim.time, OASESqp_hs_avg.t)
legend({'QP','OASESqp','OASESqphs'},'Interpreter','Latex')
legend({'OASESqp','OASESqphs'},'Interpreter','Latex')

% t_total_qp = sum(qp_avg.t)
t_total_OASES = sum(OASESqp_avg.t)
t_total_OASEShs = sum(OASESqp_hs_avg.t)

% t_max_qp = max(qp_avg.t)
t_max_OASES = max(OASESqp_avg.t)
t_max_OASEShs = max(OASESqp_hs_avg.t)

% t_mean_qp = mean(qp_avg.t)
t_mean_OASES = mean(OASESqp_avg.t)
t_mean_OASEShs = mean(OASESqp_hs_avg.t)

% t_overTs_qp = sum(qp_avg.t > Ts)
t_overTs_OASES = sum(OASESqp_avg.t > Ts)
t_overTs_OASEShs = sum(OASESqp_hs_avg.t > Ts)

% t_closeToTs_qp = sum(qp_avg.t > Ts/10)
t_closeToTs_OASES = sum(OASESqp_avg.t > Ts/10)
t_closeToTs_OASEShs = sum(OASESqp_hs_avg.t > Ts/10)

% T = [t_total_qp, t_total_OASES, t_total_OASEShs;
%     t_max_qp, t_max_OASES, t_max_OASEShs;
%     t_mean_qp, t_mean_OASES, t_mean_OASEShs;
%     t_overTs_qp, t_overTs_OASES, t_overTs_OASEShs;
%     t_closeToTs_qp, t_closeToTs_OASES, t_closeToTs_OASEShs]

T = [0, t_total_OASES, t_total_OASEShs;
    0, t_max_OASES, t_max_OASEShs;
    0, t_mean_OASES, t_mean_OASEShs;
    0, t_overTs_OASES, t_overTs_OASEShs;
    0, t_closeToTs_OASES, t_closeToTs_OASEShs]


% np = 50 nc = 10
% T =
% 
%     2.1737    0.0955    0.0931
%     0.0237    0.0005    0.0006
%     0.0022    0.0001    0.0001
%     2.0000         0         0
%   253.0000         0         0

% np = 100 nc = 20
%     2.3881    0.1048    0.0929
%     0.0233    0.0005    0.0005
%     0.0024    0.0001    0.0001
%     2.0000         0         0
%   412.0000         0         0
% 

% np = 200 nc = 40
% T =
% 
%     3.7868    0.1491    0.1069
%     0.0175    0.0005    0.0007
%     0.0038    0.0001    0.0001
%          0         0         0
%   949.0000         0         0

% np = 400 nc = 80
% T =
% 
%     5.1249    0.3835    0.1428
%     0.0183    0.0015    0.0013
%     0.0051    0.0004    0.0001
%          0         0         0
%   999.0000         0         0

% np = 800 nc = 160
% T =
% 
%          0    1.5211    0.2586
%          0    0.0035    0.0035
%          0    0.0015    0.0003
%          0         0         0
%          0   80.0000    2.0000

% np = 1600 nc = 320
% T =
% 
%          0    8.0393    0.8558
%          0    0.0203    0.0221
%          0    0.0080    0.0009
%          0    2.0000    2.0000
%          0  999.0000   10.0000
% figure
% subplot(2,1,1)
% hold on
% plot(quadprog_sim.quadprog_sim.time,quadprog_sim.quadprog_sim.signals.values(:,1))
% plot(OASESqp_sim.OASESqp_sim.time, OASESqp_sim.OASESqp_sim.signals.values(:,1))
% plot(OASESqp_hs_sim.OASESqp_hs_sim.time, OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,1))
% legend({'QP','OASESqp','OASESqphs'},'Interpreter','Latex')
% subplot(2,1,2)
% hold on
% plot(quadprog_sim.quadprog_sim.time,quadprog_sim.quadprog_sim.signals.values(:,2))
% plot(OASESqp_sim.OASESqp_sim.time, OASESqp_sim.OASESqp_sim.signals.values(:,2))
% plot(OASESqp_hs_sim.OASESqp_hs_sim.time, OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,2))
% legend({'QP','OASESqp','OASESqphs'},'Interpreter','Latex')
% xlabel('Time [s]')
% ylabel('u')
% 
% figure
% hold on
% plot(quadprog_sim.quadprog_sim.time, quadprog_sim.quadprog_sim.signals.values(:,3))
% plot(OASESqp_sim.OASESqp_sim.time, OASESqp_sim.OASESqp_sim.signals.values(:,3))
% plot(OASESqp_hs_sim.OASESqp_hs_sim.time, OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,3))
% legend({'QP','OASESqp','OASESqphs'},'Interpreter','Latex')
% 
% t_total_qp = sum(quadprog_sim.quadprog_sim.signals.values(:,3))
% t_total_OASES = sum(OASESqp_sim.OASESqp_sim.signals.values(:,3))
% t_total_OASEShs = sum(OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,3))
% 
% t_max_qp = max(quadprog_sim.quadprog_sim.signals.values(:,3))
% t_max_OASES = max(OASESqp_sim.OASESqp_sim.signals.values(:,3))
% t_max_OASEShs = max(OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,3))
% 
% t_overTs_qp = sum(quadprog_sim.quadprog_sim.signals.values(:,3) > Ts)
% t_overTs_OASES = sum(OASESqp_sim.OASESqp_sim.signals.values(:,3) > Ts)
% t_overTs_OASEShs = sum(OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,3) > Ts)
% 
% t_closeToTs_qp = sum(quadprog_sim.quadprog_sim.signals.values(:,3) > Ts/10)
% t_closeToTs_OASES = sum(OASESqp_sim.OASESqp_sim.signals.values(:,3) > Ts/10)
% t_closeToTs_OASEShs = sum(OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,3) > Ts/10)


% E = norm(e)
% ITAE = Ts*(1:501)*abs(e)'
%% TODO
% Periodicky sjednocovat linearni predikci s merenim z nelinearniho systemu
% Overit spravnost na +- 40 stupnu okolo pracovniho bodu
% Slozitejsi w


