s = tf('s');
%% Modely
g = 9.81;
l = 3.5;
m = 1;
b = 0.5;
M = 10;
Kp = 100;

wn = sqrt(g/l);
xi = b/(2*m*sqrt(g*l^3));
K = -1/l;

Ts = 0.01;
% %% x1 = fi, x2 = dfi/dt, x3 = x, x4 = dx/dt
% Aa = [0 1 0 0;
%     -g/l -b/(m*l^2) 0 0;
%     0 0 0 1;
%     0 0 0 0];
% 
% Ba = [0;-1/l;0;1];
% Ca = eye(4);
% Da = zeros(4,1);
% 
% Sa = ss(Aa,Ba,Ca,Da);
% Sd = c2d(Sa,Ts,'zoh');
% [Ad,Bd,Cd,Dd] = ssdata(Sd);

%% x1 = fi, x2 = x+l*fi, x3 = dfi/dt + 1/l*dx/dt
Av = [0 0 1;
    0 0 l;
    -g/l 0 -b/(m*l^2)];
Bv = [-1/l;0;b/(m*l^3)];
Cv = [0 1 0;1 0 0];
Dv = 0;
Cv2 = [1 0 0;
    0 0 1;
    -l 1 0;
    0 0 0];
Dv2 = [0;-1/l;0;1];

Sv = ss(Av,Bv,Cv,Dv);
Sd = c2d(Sv,Ts,'zoh');
[Ad,Bd,Cd,Dd] = ssdata(Sd);
Sv2 = ss(Av,Bv,Cv2,Dv2);
Sd2 = c2d(Sv2,Ts,'zoh');
%% Prediktivn matice pro MPC
Np = 100;
Nc = 50;
[F,G] = predictive_matrices(Ad,Bd,Cd,Np,Nc);

%% Vazbov podmnky a maticce pro MPC
vmax = 1;
amax = 20;

A = (1/Ts)*eye(Nc) - diag((1/Ts)*ones(1,Nc-1),-1);
E = [A;-A];
d = amax*ones(2*Nc,1);
% E = A;
% d = [amax*ones(Nc,1);-amax*ones(Nc,1)];
% d = amax*ones(Nc,1);
%% Kvadratick programovn
F1 = F(1:2:end,:);
F2 = F(2:2:end,:);

G1 = G(1:2:end,:);
G2 = G(2:2:end,:);

Fs = [F1;F2]; Gs = [G1;G2]; %seazeno

W = [ones(size(F1,1),1);zeros(size(F2,1),1)]; % referenn signl
Q = blkdiag(1000*eye(size(F1,1)), eye(size(F2,1)));
R = eye(Nc); % vstupn vhov matice

% Matice pro standardn tvar problmu kvadratickho programovn
H = Gs'*Q*Gs + R;
H = (H+H')/2;

% %% Pokus - srovnn
% x0 = [0;0;0];
% f = Gs'*Q*(Fs*x0-W);
% 
% U1 = qpOASES(H,f,E(1:end/2,:),-vmax*ones(size(Gs,2),1),vmax*ones(size(Gs,2),1),-d(1:end/2),d(1:end/2));
% U = quadprog(H,f,E,d,[],[],-vmax*ones(size(Gs,2),1),vmax*ones(size(Gs,2),1));

%% Porovnn
N = 5;
prog = zeros(N,10/Ts+1);
oases = zeros(N,10/Ts+1);
oasesHS = zeros(N,10/Ts+1);
for n = 1:N
sim('simul_quadprog'); 
sim('simul_qpoases'); 
sim('simul_qpoases_hs');
prog(n,:) = time_quadprog.signals.values;
oases(n,:) = time_qpoases.signals.values;
oasesHS(n,:) = time_qpoases_hs.signals.values;
end
save('files', 'prog', 'oases', 'oasesHS');
%%
figure;
subplot(3,1,1); hold on;
plot(setpoint.time, setpoint.signals.values, 'g');
plot(MPC_quadprog.time, MPC_quadprog.signals.values(:,2), 'b');
plot(MPC_qpoases.time, MPC_qpoases.signals.values(:,2), 'r--');
plot(MPC_qpoases_hs.time, MPC_qpoases_hs.signals.values(:,2), 'm--');
xlabel('Time (s)');
ylabel('Payload position (m)');
legend('Set-point', 'quadprog', 'qpOASES', 'qpOASES hot-starting', 'Location', 'Southeast');

subplot(3,1,2); hold on;
plot(MPC_quadprog.time, MPC_quadprog.signals.values(:,4),'b');
plot(MPC_qpoases.time, MPC_qpoases.signals.values(:,4),'r--');
plot(MPC_qpoases_hs.time, MPC_qpoases_hs.signals.values(:,4),'m--');
xlabel('Time (s)');
ylabel('Cart velocity (m/s)');

subplot(3,1,3); hold on;
plot(time_quadprog.time, time_quadprog.signals.values,'b');
plot(time_qpoases.time, time_qpoases.signals.values, 'r');
plot(time_qpoases_hs.time, time_qpoases_hs.signals.values, 'm');
xlabel('Time(s)');
ylabel('Computational time (s)');