clear all
close all
load('PI_P')
Theta = [0.4554  %Identifikovane parametry
        3.2503
        13.3097]
    



% 130 deg
y_lin = 130
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F130 = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F130,Ts,'zoh')
plant_ss130 = ss(Fd)

% 50 deg
y_lin = 50
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F50 = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F50,Ts,'zoh')
plant_ss50 = ss(Fd)


y_lin = 90
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F,Ts,'zoh')
plant_ss = ss(Fd)

%y_offset = 40


C1d = c2d(C1,Ts,'zoh')
C2d = c2d(C2,Ts,'zoh')
s = tf('s')
u0 = Theta(2)*sin((y_lin)*pi/180)/Theta(3) % ustaleny vstup pro y_lin

t = 0:Ts:100
%%

A = [[plant_ss.A [0;0] [0;0] [0;0]]; [0 0 1 0 0];[0 0 0 1 0]; [0 0 0 0 1]] 
B = [plant_ss.B; 0; 0; 0]
C = [plant_ss.C 0 0 0]
Ce = [plant_ss.C -1 0 0]
D = plant_ss.D


Ard = [plant_ss.A,plant_ss.B;[0 0 1]]
Brd = [plant_ss.B; 0]
Crd = [plant_ss.C 0]

Ld = acker(Ard',Crd', 7*[0.1 0.1 0.1] )'

Frekd = Ard-Ld*Crd
eig(Frekd)

% parameters
np = 50
nc = 10
% constraints
ub = (1-u0)*ones(nc,1)
lb = (0-u0)*ones(nc,1)
% weights
eW = 1 %output weight
duW = 0.1 %input weight

Q = eW*eye(size(C,1))
R = duW*eye(size(B,2))
cQ = cell(1,np)
cR = cell(1,nc)
cQ(:) = {Q}
cR(:) = {R}
Q = blkdiag(cQ{:}) % np*np
R = blkdiag(cR{:}) % nc*nc

%delta u matrices
K = eye(nc)-triu(ones(nc),-1)+triu(ones(nc),0)
M = zeros(nc,1)
M(1) = -1
L = [0 0 0 1 0]


% prediction matrices
Px = []
Hx = []
P = []
H = []
for r = 1:np
    Hx_row = [];
    H_row = [];
    for c = 1:np
        Hx_row = [Hx_row mat_pow(A, r-c)*B];
        H_row = [H_row Ce*mat_pow(A,r-c-1)*B];
    end
    Hx = [Hx ; Hx_row];
    H = [H ; H_row];
    Px = [Px ; A^r]   ;
    P = [P ; Ce*mat_pow(A,r-1)];
end
H = H - diag(diag(H))+eye(length(H))*D; %uprava prvku na diagonale


% Move blocking
% Mb lze aplikovat na uk nebo na Hx a H (v nasem pripade se aplikuje na Hx a H)
Mb = [eye(nc);[zeros(np-nc,nc-1) ones(np-nc,1)]];
Hbx = Hx*Mb;
Hb = H*Mb;

% Inicializace zaznamovych vektoru
w0 = 1.5 % REFERENCNI SIGNAL
z0 = 0.2
z1 = -0.3
z2 = -0.3

p = (P'*Q*Hb + L'*M'*R*K);
G = (Hb'*Q*Hb + K'*R*K);

phi0 = pi/2
pinv(plant_ss.C)'*phi0
xhat0 = [0 0 -u0]
% %% Estimator for Cascade controlled system to see input disturbances
% % Fo = minreal(C1*(C2*G1/(1+C2*G1)*G2))
% Fo = minreal((C2*G1/(1+C2*G1)*G2))
% Fo_ss = ss(Fo)
% 
% Arc = [Fo_ss.A,Fo_ss.B;[0 0 0 0]]
% Brc = [Fo_ss.B; 0]
% Crc = [Fo_ss.C 0]
% 
% Lc = acker(Arc',Crc', 5*[-5 -5 -1 -1] )'
% 
% Frekc = Arc-Lc*Crc
% eig(Frekc)
% rek_on = 1
%% Low-pass filter for input disturbance rejection
Fp = 1
wp = Fp*2*pi
Ts_lp = 1/wp

%%
% rek_on = 1
% rek_on = -1
% z_on = 1
% z_on = -1
% w0 = -0.5
% w0 = 0.5
% w0 = 1
% w0 = -1
% robustness = 1 % 130deg
% robustness = 0 % 90deg
% robustness = -1 % 50deg
% NS = -1
% NS = 1

% exact model, no disturbance, rek, all w0 : [[1;-1;0.5;0],[-1;-1;-0.5;0],[-1;-1;1;0],[-1;-1;-1;0],]
% exact model, disturbance, rek, all w0 : [[1;1;0.5;0],[1;1;-0.5;0],[1;1;1;0],[1;1;-1;0],]
% 50deg system, disturbance, rek, all w0 : [[1;1;0.5;-1],[1;1;-0.5;-1],[1;1;1;-1],[1;1;-1;-1],]
% 130deg system, disturbance, rek, all w0 : [[1;1;0.5;1],[1;1;-0.5;1],[1;1;1;1],[1;1;-1;1],]

% NS = 1
% NS system, disturbance, rek, all w0 : [[1;1;phi0;0],[1;1;phi0*1.5;0],[1;1;phi0*0.5;0],[1;1;phi0*2;0],]
NS = 1


k = 1
PIDvsMPC_sim = sim('PIDvsMPC_NS')
figure('Name', 'y' + string(k))
hold on
plot(PIDvsMPC_sim.PIDvsMPC_sim.time, PIDvsMPC_sim.PIDvsMPC_sim.signals.values(:,1))
plot(PIDvsMPC_sim.PIDvsMPC_sim.time, PIDvsMPC_sim.PIDvsMPC_sim.signals.values(:,2))
plot(PIDvsMPC_sim.PIDvsMPC_sim.time, PIDvsMPC_sim.PIDvsMPC_sim.signals.values(:,3))
legend({'MPC control','Cascade control','Setpoint'},'Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
ylabel('$\varphi$ [rad]','Interpreter','Latex')
title('Comparison of time responses','Interpreter','Latex')

figure('Name', 'u' + string(k))
hold on

plot(PIDvsMPC_sim.PIDvsMPC_sim.time, PIDvsMPC_sim.PIDvsMPC_sim.signals.values(:,4))
plot(PIDvsMPC_sim.PIDvsMPC_sim.time, PIDvsMPC_sim.PIDvsMPC_sim.signals.values(:,5))
legend({'MPC control','Cascade control'},'Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
ylabel('Manipulated variable $u$','Interpreter','Latex')
title('Comparison of chosen control action','Interpreter','Latex')


%%



%%
% quadprog_sim = sim('quadprog_sim')
% OASESqp_sim = sim('OASESqp_sim')
% OASESqp_hs_sim = sim('OASESqp_hs_sim')
%%
% figure
% subplot(3,1,1)
% hold on
% plot(quadprog_sim.quadprog_sim.time,quadprog_sim.quadprog_sim.signals.values(:,1))
% plot(OASESqp_sim.OASESqp_sim.time, OASESqp_sim.OASESqp_sim.signals.values(:,1))
% plot(OASESqp_hs_sim.OASESqp_hs_sim.time, OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,1))
% legend({'QP','OASESqp','OASESqp_hs'},'Interpreter','Latex')
% subplot(3,1,2)
% hold on
% plot(quadprog_sim.quadprog_sim.time,quadprog_sim.quadprog_sim.signals.values(:,2))
% plot(OASESqp_sim.OASESqp_sim.time, OASESqp_sim.OASESqp_sim.signals.values(:,2))
% plot(OASESqp_hs_sim.OASESqp_hs_sim.time, OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,2))
% legend({'QP','OASESqp','OASESqp_hs'},'Interpreter','Latex')
% xlabel('Time [s]')
% ylabel('u')
% subplot(3,1,3)
% hold on
% plot(quadprog_sim.quadprog_sim.time, quadprog_sim.quadprog_sim.signals.values(:,3))
% plot(OASESqp_sim.OASESqp_sim.time, OASESqp_sim.OASESqp_sim.signals.values(:,3))
% plot(OASESqp_hs_sim.OASESqp_hs_sim.time, OASESqp_hs_sim.OASESqp_hs_sim.signals.values(:,3))
% legend({'QP','OASESqp','OASESqp_hs'},'Interpreter','Latex')
% E = norm(e)
% ITAE = Ts*(1:501)*abs(e)'
%% TODO
% Periodicky sjednocovat linearni predikci s merenim z nelinearniho systemu
% Overit spravnost na +- 40 stupnu okolo pracovniho bodu
% Slozitejsi w


