clear
Theta = [0.4554  
        3.2503
        13.3097]
A = [-Theta(1) -Theta(2)*cos(90*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
linSys90 = tf(ss(A,B,C,D))

A = [-Theta(1) -Theta(2)*cos(50*pi/180);
    1   0];
linSys50 = tf(ss(A,B,C,D))

A = [-Theta(1) -Theta(2)*cos(130*pi/180);
    1   0];
linSys130 = tf(ss(A,B,C,D))

s = tf('s')

%% PID

% Neprilis dobry PID regulator
K = 0.3492
Ti = 3.3397
Td = 0.8349
N = 10
PID = K*(1+1/(Ti*s)+Td*s/(Td/N*s+1))

Fz50 = linSys50*PID/(1+linSys50*PID)
Fz90 = linSys90*PID/(1+linSys90*PID)
Fz130 = linSys130*PID/(1+linSys130*PID)
figure
hold on
step(Fz50)
step(Fz90)
step(Fz130)
title('PID control')
legend('Linearizovan v 50stupnich','Linearizovan v 90stupnich', 'Linearizovan v 130stupnich')

%% P + PI
% From sisotool
C1 = 1.3355 % P controller
C2 = 0.38697*(s+0.6533)/s % PI controller

plant = linSys50
G1 = plant*s
G2 = 1/s
Fo1 = C2*G1
Fz1 = Fo1/(1+Fo1)
Fo2 = C1* Fz1* G2
Fz2_50 = Fo2/(1+Fo2)

plant = linSys90
G1 = plant*s
G2 = 1/s
Fo1 = C2*G1
Fz1 = Fo1/(1+Fo1)
Fo2 = C1* Fz1* G2
Fz2_90 = Fo2/(1+Fo2)

plant = linSys130
G1 = plant*s
G2 = 1/s
Fo1 = C2*G1
Fz1 = Fo1/(1+Fo1)
Fo2 = C1* Fz1* G2
Fz2_130 = Fo2/(1+Fo2)
%%
[Y50, T50] = step(Fz2_50)
[Y90, T90] = step(Fz2_90)
[Y130, T130] = step(Fz2_130)
figure
hold on
plot(T50,Y50)
plot([T90; T90(end); 10],[Y90; Y90(end); Y90(end)])
plot([T130; T130(end); 10],[Y130; Y130(end); Y130(end)])
title('Cascade control performance','fontsize',14,'interpreter','latex')
legend({'Plant linearized at $\varphi^* = 50^{\circ}$', 'Plant linearized at $\varphi^* = 90^{\circ}$', 'Plant linearized at $\varphi^* = 130^{\circ}$'},'Interpreter','latex')
xlabel('Time[s]','fontsize',14,'interpreter','latex')
ylabel('Output','fontsize',14,'interpreter','latex')